package org.enhydra.demo.wizard.tools;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.enhydra.shark.Shark;
import org.enhydra.shark.api.client.wfmc.wapi.WMSessionHandle;
import org.enhydra.shark.api.client.wfmodel.WfActivity;
import org.enhydra.shark.api.client.wfservice.AdminMisc;
import org.enhydra.shark.api.client.wfservice.SharkConnection;
import org.enhydra.shark.api.client.wfservice.WMEntity;
import org.enhydra.shark.api.internal.toolagent.AppParameter;
import org.enhydra.shark.api.internal.toolagent.ApplicationBusy;
import org.enhydra.shark.api.internal.toolagent.ApplicationNotDefined;
import org.enhydra.shark.api.internal.toolagent.ApplicationNotStarted;
import org.enhydra.shark.api.internal.toolagent.ToolAgentGeneralException;
import org.enhydra.shark.toolagent.AbstractToolAgent;
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class CalculationTool extends AbstractToolAgent {
   public void invokeApplication(WMSessionHandle _shandle,
                                 long _handle,
                                 WMEntity _appInfo,
                                 WMEntity _toolInfo,
                                 String _applicationName,
                                 String _procInstId,
                                 String _assId,
                                 AppParameter[] _parameters,
                                 Integer _appMode)
      throws ApplicationNotStarted,
         ApplicationNotDefined,
         ApplicationBusy,
         ToolAgentGeneralException {
      super.invokeApplication(_shandle,
                              _handle,
                              _appInfo,
                              _toolInfo,
                              _applicationName,
                              _procInstId,
                              _assId,
                              _parameters,
                              _appMode);
      Map what2update = new HashMap();
      AdminMisc adm = Shark.getInstance().getAdminMisc();
      SharkConnection sconn = Shark.getInstance().getSharkConnection();
      try {
         this.status = APP_STATUS_ACTIVE;
         sconn.attachToHandle(shandle);
         WfActivity a = sconn.getActivity(procInstId,
                                          adm.getAssignmentActivityId(shandle,
                                                                      procInstId,
                                                                      assId));
         Map conxt = a.process_context();
         DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
         dbf.setNamespaceAware(true);
         DocumentBuilder db = dbf.newDocumentBuilder();
         Document doc = db.newDocument();

         String[] arrValue = {
               "Puerto de la Cruz",
               "Rome",
               "Mont Blanc",
               "Kassandra",
               "Vienna",
               "Hammamet",
               "Beirut",
               "Paris"
         };
         java.util.Date startDate = (Date) conxt.get("start_date");
         java.util.Date endDate = (Date) conxt.get("end_date");
         int numDays = (int) ((endDate.getTime() - startDate.getTime())/86400000);

         Random r = new Random(System.currentTimeMillis());
         Attr ns = doc.createAttribute("xmlns:an");
         ns.setNodeValue("http://www.together.at/2006/ANOTHER");
         Element root = doc.createElementNS("http://www.together.at/2006/ANOTHER",
                                            "an:itemset");
         root.setAttributeNodeNS(ns);
         for (int i = 0; i < arrValue.length; i++) {
            if (r.nextBoolean()) {
               Element el = doc.createElement("an:item");
               Attr at = doc.createAttribute("Id");
               at.setNodeValue("item_repeat" + i);
               el.setAttributeNode(at);

               at = doc.createAttribute("Value");
               at.setNodeValue(arrValue[i]);
               el.setAttributeNode(at);

               at = doc.createAttribute("Count");
               int price = ((arrValue[i].hashCode() % 1991) * numDays);
               if (price < 0) {
                  price = -price;
               }
               at.setNodeValue(String.valueOf(price / 100f));
               el.setAttributeNode(at);

               at = doc.createAttribute("Selected");
               at.setNodeValue("false");
               el.setAttributeNode(at);

               root.appendChild(el);
            }
         }
         doc.appendChild(root);
         // TransformerFactory.newInstance()
         // .newTransformer()
         // .transform(new DOMSource(doc), new StreamResult(System.out));
         what2update.put("repeat_set", doc);
         a.set_result(what2update);
         this.status = APP_STATUS_FINISHED;

      } catch (Exception e) {
         this.status = APP_STATUS_INVALID;
         if (e instanceof ApplicationNotStarted) {
            throw (ApplicationNotStarted) e;
         } else if (e instanceof ApplicationNotDefined) {
            throw (ApplicationNotDefined) e;
         } else if (e instanceof ApplicationBusy) {
            throw (ApplicationBusy) e;
         } else if (e instanceof ToolAgentGeneralException) {
            throw (ToolAgentGeneralException) e;
         } else {
            e.printStackTrace();
            throw new ToolAgentGeneralException(e);
         }
      }
   }
}
