/*
 * wizard This type of presentation object could be the target of a form's submit button,
 * process the data, and then decide where to send the user (back or on to the next page).
 */

package org.enhydra.wlh.presentation;

import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;
import java.util.Map;

import javax.xml.namespace.QName;

import org.apache.xmlbeans.XmlCursor;
import org.enhydra.shark.Shark;
import org.enhydra.shark.api.client.wfmc.wapi.WMConnectInfo;
import org.enhydra.shark.api.client.wfmodel.WfProcess;
import org.enhydra.shark.api.client.wfservice.SharkConnection;
import org.enhydra.shark.xpil.XPILExtendedWorkflowFacilityInstanceDocument;
import org.enhydra.shark.xpil.XPILBooleanDataInstanceDocument.BooleanDataInstance;
import org.enhydra.shark.xpil.XPILDateDataInstanceDocument.DateDataInstance;
import org.enhydra.shark.xpil.XPILDoubleDataInstanceDocument.DoubleDataInstance;
import org.enhydra.shark.xpil.XPILExtendedWorkflowFacilityInstanceDocument.ExtendedWorkflowFacilityInstance;
import org.enhydra.shark.xpil.XPILLongDataInstanceDocument.LongDataInstance;
import org.enhydra.shark.xpil.XPILMainWorkflowProcessInstanceDocument.MainWorkflowProcessInstance;
import org.enhydra.shark.xpil.XPILManualActivityInstanceDocument.ManualActivityInstance;
import org.enhydra.shark.xpil.XPILStringDataInstanceDocument.StringDataInstance;
import org.enhydra.wlh.presentation.BasePO;
import org.enhydra.wlh.spec.utils.ParamConsts;
import org.enhydra.xml.io.OutputOptions;
import org.w3c.dom.Node;

import com.lutris.appserver.server.httpPresentation.HttpPresentationException;
import com.lutris.logging.Logger;

public class DocumentPresentation extends BasePO {
    String format = "fop-pdf";
   public Node handleDefault() throws HttpPresentationException {
      String pro_Id = myComms.request.getParameter(ParamConsts.PROCESS_ID);
      String newformat = myComms.request.getParameter("format");
      if (newformat!=null && !newformat.equals("")){
          format = newformat;
      }
      try {
         SharkConnection sc = Shark.getInstance().getSharkConnection();
         WMConnectInfo wmci = new WMConnectInfo(getUsername(), "", "", "");
         sc.connect(wmci);
         WfProcess pi = sc.getProcess(pro_Id);
         Map m = pi.process_context();
         Map c = pi.manager().context_signature();
         sc.disconnect();
         return createNode(pro_Id, m, c);
      } catch (Exception ex) {
         myComms.application.getLogChannel().write(Logger.ERROR, "", ex);
      }
      return null;
   }

   protected boolean loggedInUserRequired() {
      return false;
   }

   public OutputOptions getPostProcessingOptions() throws HttpPresentationException {
      OutputOptions ret = new OutputOptions();
      ret.setMIMEType("text/xml+"+format);
      return ret;
   }

   protected String getUsername() {
      return "anonymous";
   }

   protected Node createNode(String pro_Id, Map m, Map c) {
      XPILExtendedWorkflowFacilityInstanceDocument tws = XPILExtendedWorkflowFacilityInstanceDocument.Factory.newInstance();
      tws.addNewExtendedWorkflowFacilityInstance();
      ExtendedWorkflowFacilityInstance ins = tws.getExtendedWorkflowFacilityInstance();
      MainWorkflowProcessInstance p = ins.addNewMainWorkflowProcessInstance();
      p.setId(pro_Id);
      ManualActivityInstance a = ins.addNewManualActivityInstance();
      a.setId("1");

      for (Iterator iter = m.entrySet().iterator(); iter.hasNext();) {
         Map.Entry element = (Map.Entry) iter.next();
         String varName = (String) element.getKey();
         Object varValue = element.getValue();
         String varType = (String) c.get(varName);
         if ("java.lang.String".equals(varType)) {
            StringDataInstance nsdi = ins.addNewStringDataInstance();
            nsdi.setId(varName);
            nsdi.setValue((String) varValue);
         } else if ("java.lang.Double".equals(varType)) {
            DoubleDataInstance nddi = ins.addNewDoubleDataInstance();
            nddi.setId(varName);
            nddi.setValue(((Double) varValue).doubleValue());
         } else if ("java.lang.Boolean".equals(varType)) {
            BooleanDataInstance nbdi = ins.addNewBooleanDataInstance();
            nbdi.setId(varName);
            nbdi.setValue(((Boolean) varValue).booleanValue());
         } else if ("java.lang.Long".equals(varType)) {
            LongDataInstance nldi = ins.addNewLongDataInstance();
            nldi.setId(varName);
            nldi.setValue(((Long) varValue).longValue());
         } else if ("java.util.Date".equals(varType)) {
            DateDataInstance nddi = ins.addNewDateDataInstance();
            nddi.setId(varName);
            Calendar date = Calendar.getInstance();
            date.setTime((Date) varValue);
            nddi.setValue(date);
         } else {
            // UNKNOWN
         }
      }
      String s;
      XmlCursor c1 = ins.newCursor();

      while (c1.hasNextToken()) {
         if (c1.isNamespace())
            c1.removeXml();
         else {
            if (c1.isStart()) {
               s = c1.getName().getLocalPart();
               c1.setName(new QName(s));
            }
         }
         c1.toNextToken();

      }
      System.out.println(tws.xmlText());
      return tws.getDomNode();
   }
}
