/*
 *  wizard 
 *
 *  Enhydra super-servlet specification object
 *  
 */
package org.enhydra.demo.wizard.spec;

public class CounterFactory {
	
    /**
     * Constructor can't be used.
     */
    private CounterFactory() {
    }
    
    /**
     * Create a counter as state object/value object/data transfer object
     */
    public static Counter createCounter(String fullClassName) {
        Counter result = null;
        Class objectClass = null;

        try {
            // Create the object
            objectClass = Class.forName(fullClassName);
            result = (Counter) objectClass.newInstance();
        } catch (Exception ex) {
        	System.out.println("Problems encountered while getting Counter implementation!");
        }

        return result;
    }
}
