/*
 *  wizard 
 *
 *  Enhydra super-servlet specification object
 *  
 */
package org.enhydra.demo.wizard.spec;

public class DaterFactory {
    
    /**
     * Constructor can't be used.
     */
    private DaterFactory() {
    }

    /**
     * Create a dater as state object/value object/data transfer object
     */
    public static Dater createDater(String fullClassName) {
        Dater result = null;
        Class objectClass = null;

        try {
            // Create the value object
            objectClass = Class.forName(fullClassName);
            result = (Dater) objectClass.newInstance();
        } catch (Exception ex) {
            System.out.println("Problems encountered while getting Dater implementation!");
        }

        return result;
    }
}
