package org.enhydra.wlh.business;

/**
 * @author Milin Radivoj
 */
import java.io.StringReader;
import java.io.StringWriter;
import java.util.Iterator;
import java.util.Map;

import javax.xml.transform.Templates;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamSource;

import org.enhydra.wlh.spec.TransformManager;

public class TransformManagerImpl implements TransformManager {

   public String transform(String content, String xslPath) throws Exception {

      try {
         TransformerFactory tFactory = TransformerFactory.newInstance();

         Templates stylesheet = tFactory.newTemplates(new StreamSource(xslPath));
         Transformer transformer = stylesheet.newTransformer();

         StringWriter stringWriter = new StringWriter();

         transformer.setParameter("bogda", "setfrom java");
         transformer.transform(new StreamSource(new StringReader(content)),
                               new javax.xml.transform.stream.StreamResult(stringWriter));
         String result = stringWriter.toString();
         return result;
      } catch (Exception e) {
         e.printStackTrace();
         return new String();
      }
   }

   public String transform(String content, String xslPath, Map map) throws Exception {

      try {
         TransformerFactory tFactory = TransformerFactory.newInstance();

         Templates stylesheet = tFactory.newTemplates(new StreamSource(xslPath));
         Transformer transformer = stylesheet.newTransformer();

         StringWriter stringWriter = new StringWriter();

         Iterator iter = map.keySet().iterator();

         while (iter.hasNext()) {

            String key = (String) iter.next();
            String value = (String) map.get(key);

            transformer.setParameter(key, value);

         }
         transformer.transform(new StreamSource(new StringReader(content)),
                               new javax.xml.transform.stream.StreamResult(stringWriter));
         String result = stringWriter.toString();
         return result;
      } catch (Exception e) {
         e.printStackTrace();
         return new String();
      }
   }

}
