package org.enhydra.wlh.business;

import java.io.OutputStream;
import java.util.HashMap;
import java.util.Map;

import org.enhydra.shark.Shark;
import org.enhydra.shark.api.client.wfmc.wapi.WMConnectInfo;
import org.enhydra.shark.api.client.wfservice.SharkConnection;
import org.enhydra.shark.xpil.XPILExtendedWorkflowFacilityInstanceDocument;
import org.enhydra.wlh.spec.TransformManager;
import org.enhydra.wlh.spec.TransformManagerFactory;
import org.enhydra.wlh.spec.XMLBuilder;

import com.lutris.util.Config;

/**
 * @author Nenad
 */

public abstract class XMLBuilderImpl implements XMLBuilder {
   
   protected String sortCriterion;
   
   protected String sortAsc;

   protected String username = null;

   protected Config config = null;

   protected String total_number;

   protected String to_element;

   protected String from_element;
   
   protected String fromPage;

   public String getResult(String tempPath) throws Exception {
      XPILExtendedWorkflowFacilityInstanceDocument eWF = createExtendedWorkflowFacilityInstance();

      TransformManager manager = TransformManagerFactory.getTransformManager("org.enhydra.wlh.business.TransformManagerImpl");

      Map map = new HashMap();
      
      if(this.sortCriterion == null) {
         this.sortCriterion = "";
      }
      if(this.sortAsc == null) {
         this.sortAsc = "true";
      }
      if(this.fromPage == null) {
         this.fromPage = "";
      }
      

      map.put("username", username);
      map.put("to_element", to_element);
      map.put("from_element", from_element);
      map.put("total_number", total_number);
      map.put("sortCriterion", this.sortCriterion);
      map.put("sortAsc", this.sortAsc);
      map.put("fromPage", this.fromPage);

      return manager.transform(eWF.xmlText(), tempPath, map);

   }

   public void writeResult(OutputStream os) throws Exception {
      XPILExtendedWorkflowFacilityInstanceDocument eWF = createExtendedWorkflowFacilityInstance();
      eWF.save(os);
   }

   protected XPILExtendedWorkflowFacilityInstanceDocument createExtendedWorkflowFacilityInstance()
      throws Exception {

      XPILExtendedWorkflowFacilityInstanceDocument eWFD = null;
      SharkConnection sc = Shark.getInstance().getSharkConnection();
      WMConnectInfo wmci = new WMConnectInfo(username, "", "", "");
      sc.connect(wmci);
      eWFD = fillXMLElements(sc);
      sc.disconnect();

      return eWFD;
   }

   protected abstract XPILExtendedWorkflowFacilityInstanceDocument fillXMLElements(SharkConnection sc)
      throws Exception;

}
