package org.enhydra.wlh.business;

import java.sql.Date;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.enhydra.shark.Shark;
import org.enhydra.shark.api.client.wfmc.wapi.WMFilter;
import org.enhydra.shark.api.client.wfservice.SharkConnection;
import org.enhydra.shark.api.client.wfservice.WMEntity;
import org.enhydra.shark.api.client.wfservice.WMEntityIterator;
import org.enhydra.shark.api.client.wfservice.XPDLBrowser;
import org.enhydra.shark.xpil.XPILExtendedWorkflowFacilityInstanceDocument;
import org.enhydra.shark.xpil.XPDLPackageDocument.Package;
import org.enhydra.shark.xpil.XPILExtendedWorkflowFacilityInstanceDocument.ExtendedWorkflowFacilityInstance;
import org.enhydra.shark.xpil.XPILHeaderDocument.Header;
import org.enhydra.shark.xpil.XPILInstanceExtendedAttributeDocument.InstanceExtendedAttribute;
import org.enhydra.shark.xpil.XPILPackageInstanceDocument.PackageInstance;
import org.enhydra.shark.xpil.XPILPackageInstancesDocument.PackageInstances;
import org.enhydra.wlh.spec.utils.ParamConsts;

import com.lutris.util.Config;

public class XMLPackageManagementInstanceBuilder extends XMLBuilderImpl {

   public XMLPackageManagementInstanceBuilder(String username,
                                              Config config,
                                              String startElement,
                                              String sortCriterion,
                                              String sortAsc) {
      this.username = username;
      this.config = config;
      this.from_element = startElement;
      this.sortCriterion = sortCriterion;
      this.sortAsc = sortAsc;

   }

   protected XPILExtendedWorkflowFacilityInstanceDocument fillXMLElements(SharkConnection sc)
      throws Exception {

      Map tempMap = new HashMap();
      boolean opened = false;

      tempMap.clear();
      XPILExtendedWorkflowFacilityInstanceDocument tws = XPILExtendedWorkflowFacilityInstanceDocument.Factory.newInstance();

      tws.addNewExtendedWorkflowFacilityInstance();

      ExtendedWorkflowFacilityInstance ins = tws.getExtendedWorkflowFacilityInstance();
      ins.addNewHeader();
      Header header = tws.getExtendedWorkflowFacilityInstance().getHeader();
      header.setXPILVersion("1.0");
      header.setXPILVendor("Shark");

      GregorianCalendar gC = new GregorianCalendar();
      gC.setTime(new Date(System.currentTimeMillis()));

      header.setCreationTime(gC);

      header.setInstanceDescription("Shark's packages instance list");
      RepositoryManager rm = RepositoryManager.getInstance();
      String xpdlRepository = config.getString("WorkListHandler."
                                               + ParamConsts.PROPERTY_PREFIX_REPOSITORY
                                               + ".XPDL_repository");
      rm.setPathToXPDLRepositoryFolder(xpdlRepository);
      Map idMap = rm.getPackagePathToIdMapping();

      int itemsPerPage = config.getInt("WorkListHandler."
                                       + ParamConsts.PROPERTY_PREFIX_PACKAGELIST
                                       + ".max.rows.per.page", 5);

      int startAt = Integer.parseInt(from_element != null ? from_element : "0");

      XPDLBrowser ent = Shark.getInstance().getXPDLBrowser();
      WMFilter filter = new WMFilter("Type", WMFilter.EQ, "");

      WMEntityIterator ei = ent.listEntities(sc.getSessionHandle(), null, filter, true);
       WMEntity[] oo=new WMEntity[ei.getCount()];
       for(int j=0;j<ei.getCount();j++){
       oo[j]=(WMEntity) ei.next();
       }
       int criterion=1;
       
       
        if(sortCriterion.equalsIgnoreCase("id"))
           criterion=1;
        else if(sortCriterion.equalsIgnoreCase("name"))
           criterion=2;
        else if(sortCriterion.equalsIgnoreCase("version"))
           criterion=3;
        
      Arrays.sort(oo,new PackageComparator((Boolean.valueOf( this.sortAsc ).booleanValue()),criterion));
      int hm = ei.getCount();

      if (startAt > hm) {
         startAt = (hm / itemsPerPage) * itemsPerPage;

         from_element = Integer.toString(startAt);

      } else if (startAt == hm && hm > 0) {
         startAt = startAt - itemsPerPage;
         from_element = Integer.toString(startAt);
      }

      from_element = Integer.toString(startAt);
      to_element = Integer.toString(startAt + itemsPerPage - 1);
      total_number = Integer.toString(hm);

      int endEl=hm-1;
      
      if(endEl>(startAt + itemsPerPage - 1)){
         endEl=(startAt + itemsPerPage - 1);
      }
      PackageInstances pis = ins.addNewPackageInstances();

      ArrayList al = new ArrayList();
      al.clear();
      for (int j = 0; j<oo.length; j++){
         WMEntity entemp = (WMEntity)oo[j];
         al.add(entemp.getPkgId());
      }
      
      
      for (int i = startAt; i < endEl+1; i++) {
         WMEntity en = (WMEntity)oo[i];

         PackageInstance pi = pis.addNewPackageInstance();

         Package p = Package.Factory.newInstance();

         p.setName(en.getName());
         p.setId(en.getPkgId());

         pi.setId(en.getPkgId());
         pi.setVersion(en.getPkgVer());
         pi.setPackage(p);
         
      }
      Iterator itk = idMap.keySet().iterator();
      while (itk.hasNext()) {
         Object key = itk.next();
         opened = false;
         for (int i = 0; i < al.size(); i++) {
            if ((idMap.get(key).toString()).equals(al.get(i).toString())) {
               opened = true;
            }
         }
         if (!opened) {
            tempMap.put(key, idMap.get(key));

         }
      }

      InstanceExtendedAttribute[] iea = null;
      iea = new InstanceExtendedAttribute[tempMap.size()];

      Iterator itm = tempMap.keySet().iterator();
      int i = 0;
      while (itm.hasNext()) {
         InstanceExtendedAttribute ie = InstanceExtendedAttribute.Factory.newInstance();
         Object o = itm.next();
         ie.setName((String) o);
         iea[i] = ie;
         i++;
      }

      pis.addNewInstanceExtendedAttributes().setInstanceExtendedAttributeArray(iea);

      return tws;
   }

}
class PackageComparator implements Comparator {

   protected boolean ascending;
   
   protected int sortCriterium;

   public PackageComparator(boolean asc, int sortCriterium) {
      
      this.ascending=asc;
      
      this.sortCriterium=sortCriterium;
      
   }

   public int compare(Object first, Object second) {
      if (first instanceof WMEntity && second instanceof WMEntity) {
         try {
            WMEntity wme1 = ((WMEntity) first);
            WMEntity wme2 = ((WMEntity) second);
            String str1="";
            String str2="";
            /*
             * 1 - Id
             * 2 - Name
             * 3 - Version
             */
            switch(sortCriterium){
               case 1:
                   str1=wme1.getPkgId();
                   str2=wme2.getPkgId();
                  break;
               case 2:
                   str1=wme1.getName();
                   str2=wme2.getName();
                  break;
               case 3:
                  str1=wme1.getPkgVer();
                  str2=wme2.getPkgVer();
                  break;
            }
            if (ascending) {
               return str1.compareTo(str2);
            }
            return str2.compareTo(str1);
         } catch (Exception ex) {
            // exception can happen if there's no value in sorted column
         }
      }

      return 1;
}
} 