package org.enhydra.wlh.business;

import java.sql.Date;
import java.util.ArrayList;
import java.util.GregorianCalendar;
import java.util.Iterator;
import java.util.Map;

import org.enhydra.shark.api.client.wfservice.SharkConnection;
import org.enhydra.shark.xpil.XPILExtendedWorkflowFacilityInstanceDocument;
import org.enhydra.shark.xpil.XPILExtendedWorkflowFacilityInstanceDocument.ExtendedWorkflowFacilityInstance;
import org.enhydra.shark.xpil.XPILHeaderDocument.Header;
import org.enhydra.shark.xpil.XPILInstanceExtendedAttributeDocument.InstanceExtendedAttribute;
import org.enhydra.shark.xpil.XPILInstanceExtendedAttributesDocument.InstanceExtendedAttributes;
import org.enhydra.shark.xpil.XPILPackageInstancesDocument.PackageInstances;
import org.enhydra.wlh.spec.utils.ParamConsts;

import com.lutris.util.Config;

public class XMLPackageUpdateBuilder extends XMLBuilderImpl {

   String paskageName = "";

   public XMLPackageUpdateBuilder(String username,
                                  Config config,
                                  String startElement,
                                  String sortCriterion,
                                  String sortAsc,
                                  String pac) {

      this.username = username;
      this.config = config;
      this.from_element = startElement;
      this.sortCriterion = sortCriterion;
      this.sortAsc = sortAsc;
      paskageName = pac;

   }

   protected XPILExtendedWorkflowFacilityInstanceDocument fillXMLElements(SharkConnection sc)
      throws Exception {
      XPILExtendedWorkflowFacilityInstanceDocument tws = XPILExtendedWorkflowFacilityInstanceDocument.Factory.newInstance();

      tws.addNewExtendedWorkflowFacilityInstance();
      boolean notempty = false;

      ExtendedWorkflowFacilityInstance ins = tws.getExtendedWorkflowFacilityInstance();
      ins.addNewHeader();
      Header header = tws.getExtendedWorkflowFacilityInstance().getHeader();
      header.setXPILVersion("1.0");
      header.setXPILVendor("Shark");

      GregorianCalendar gC = new GregorianCalendar();
      gC.setTime(new Date(System.currentTimeMillis()));

      header.setCreationTime(gC);

      header.setInstanceDescription("Shark's packages instance list");

      int itemsPerPage = config.getInt("WorkListHandler."
                                       + ParamConsts.PROPERTY_PREFIX_REPOSITORY
                                       + ".max.rows.per.page", 5);

      PackageInstances pis = ins.addNewPackageInstances();

      RepositoryManager rm = RepositoryManager.getInstance();
      String xpdlRepository = config.getString("WorkListHandler."
                                               + ParamConsts.PROPERTY_PREFIX_REPOSITORY
                                               + ".XPDL_repository");
      rm.setPathToXPDLRepositoryFolder(xpdlRepository);
      Map idMap = rm.getPackagePathToIdMapping();
      ArrayList all = new ArrayList();

      Iterator iter = idMap.keySet().iterator();
      while (iter.hasNext()) {
         Object key = iter.next();
         if (idMap.get(key).equals(paskageName))
            all.add(key);
      }

      InstanceExtendedAttribute[] iea = new InstanceExtendedAttribute[all.size()];

      for (int i = 0; i < all.size(); i++) {
         InstanceExtendedAttribute ea = InstanceExtendedAttribute.Factory.newInstance();
         ea.setName(all.get(i).toString());
         iea[i] = (InstanceExtendedAttribute) ea;
         notempty = true;
      }
      InstanceExtendedAttributes ia = pis.addNewInstanceExtendedAttributes();
      if (notempty) {
         ia.setInstanceExtendedAttributeArray(iea);
      }

      int hm = all.size();
      int startAt = Integer.parseInt(from_element != null ? from_element : "0");

      if (startAt > hm) {
         startAt = (hm / itemsPerPage) * itemsPerPage;

         from_element = Integer.toString(startAt);

      } else if (startAt == hm && hm > 0) {
         startAt = startAt - itemsPerPage;
         from_element = Integer.toString(startAt);
      }

      from_element = Integer.toString(startAt);
      to_element = Integer.toString(startAt + itemsPerPage - 1);
      total_number = Integer.toString(hm);

      return tws;
   }

}
