package org.enhydra.wlh.business;

import java.sql.Date;
import java.util.GregorianCalendar;

import org.enhydra.shark.Shark;
import org.enhydra.shark.api.client.wfmodel.WfActivity;
import org.enhydra.shark.api.client.wfmodel.WfProcess;
import org.enhydra.shark.api.client.wfmodel.WfProcessMgr;
import org.enhydra.shark.api.client.wfservice.AdminMisc;
import org.enhydra.shark.api.client.wfservice.SharkConnection;
import org.enhydra.shark.api.client.wfservice.WMEntity;
import org.enhydra.shark.xpil.XPILExtendedWorkflowFacilityInstanceDocument;
import org.enhydra.shark.xpil.XPILExtendedWorkflowFacilityInstanceDocument.ExtendedWorkflowFacilityInstance;
import org.enhydra.shark.xpil.XPILHeaderDocument.Header;
import org.enhydra.shark.xpil.XPILPackageInstanceDocument.PackageInstance;
import org.enhydra.shark.xpil.XPILWorkflowProcessFactoryInstanceDocument.WorkflowProcessFactoryInstance;
import org.enhydra.wlh.spec.utils.ParamConsts;

import com.lutris.util.Config;

public class XMLProcessDetailBuilder extends XMLBuilderImpl {

   String process_id = "";
   

   public XMLProcessDetailBuilder(String username,
                                  Config config,String from,String sort_cr,String sort_as,
                                  String pro_id,String page) {

      this.username = username;
      this.config = config;
      this.process_id = pro_id;
      this.fromPage=page;
      this.from_element=from;
      this.sortCriterion = sort_cr;
      this.sortAsc = sort_as;

   }

   protected XPILExtendedWorkflowFacilityInstanceDocument fillXMLElements(SharkConnection sc)
      throws Exception {
      XPILExtendedWorkflowFacilityInstanceDocument tws = XPILExtendedWorkflowFacilityInstanceDocument.Factory.newInstance();

      tws.addNewExtendedWorkflowFacilityInstance();

      ExtendedWorkflowFacilityInstance ins = tws.getExtendedWorkflowFacilityInstance();
      ins.addNewHeader();
      Header header = tws.getExtendedWorkflowFacilityInstance().getHeader();
      header.setXPILVersion("1.0");
      header.setXPILVendor("Shark");

      GregorianCalendar gC = new GregorianCalendar();
      gC.setTime(new Date(System.currentTimeMillis()));

      header.setCreationTime(gC);

      header.setInstanceDescription("Shark's process details");

      int startAt = Integer.parseInt(from_element != null ? from_element : "0");
      from_element = Integer.toString(startAt);

      to_element = Integer.toString(10);
      total_number = Integer.toString(10);

      try {
         WfProcess wfp = sc.getProcess(process_id);
         WfProcessMgr wfpm = wfp.manager();

         WorkflowProcessFactoryInstance[] wfpi = new WorkflowProcessFactoryInstance[1];
         wfpi[0] = SharkXPILBindingUtils.getProcessFactory(sc,
                                                           config,
                                                           "processdetails",
                                                           (WfProcessMgr) wfpm);

         AdminMisc am = Shark.getInstance().getAdminMisc();
         WMEntity pDefEnt = am.getProcessDefinitionInfoByUniqueProcessDefinitionName(sc.getSessionHandle(),
                                                                                     wfpm.name());
         wfpi[0].setDefinitionId(pDefEnt.getId());
         
         if (wfp.requester() instanceof WfActivity) {
            SharkXPILBindingUtils.fillProcess(sc,
                                              config,
                                              ParamConsts.PROPERTY_PREFIX_PROCESSDETAILS,
                                              wfp,
                                              wfpi[0].addNewWorkflowProcessInstances().addNewSubWorkflowProcessInstance());
          
         } else {
            SharkXPILBindingUtils.fillProcess(sc,
                                              config,
                                              ParamConsts.PROPERTY_PREFIX_PROCESSDETAILS,
                                              wfp,
                                              wfpi[0].addNewWorkflowProcessInstances().addNewMainWorkflowProcessInstance());
         
           
         }
       
         PackageInstance pi = PackageInstance.Factory.newInstance();
         PackageInstance[] piarr = new PackageInstance[1];
         pi.setId(pDefEnt.getPkgId());
         pi.setVersion(((WfProcessMgr) wfpm).version());
         piarr[0] = pi;
         
       
        piarr[0].addNewWorkflowProcessFactoryInstances().setWorkflowProcessFactoryInstanceArray(wfpi);
        

        

         tws.getExtendedWorkflowFacilityInstance().setPackageInstanceArray(piarr);

      } catch (Exception e) {
         // TODO Auto-generated catch block
         e.printStackTrace();
      }

      return tws;
   }

}
