<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	exclude-result-prefixes="xpil"
	xmlns:xpil="http://www.together.at/2006/XPIL1.0"
	xmlns:xpdl="http://www.wfmc.org/2002/XPDL1.0" version="1.0">
	<xsl:output method="html" />
	<xsl:param name="username" select="u" />
	<xsl:param name="from_element" select="11" />
	<xsl:param name="to_element" select="20" />
	<xsl:param name="sortCriterion" select="20" />
	<xsl:param name="sortAsc" select="true" />
	<xsl:param name="total_number" select="200" />
	<xsl:param name="navig_url" select="PackageHandlerPO.po" />
	<xsl:include xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
		href="navigation.xsl" />
	<xsl:template match="xpil:ExtendedWorkflowFacilityInstance">
		<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
				<title>Package Instances</title>
				<link rel="stylesheet" type="text/css"
					href="media/wlh.css" />
				<script type="text/javascript">
					function submitForm(formId, actionAttr) { var
					formTag = document.getElementById(formId);
					formTag.action=actionAttr; formTag.submit(); }
					function submitFormEvent(formId, actionAttr,event) {
					var formTag = document.getElementById(formId);
					formTag.action=actionAttr;
					formTag.event.value=event; formTag.submit(); }
				</script>
			</head>
			<body class="body_home">
				<form id="mainForm" name="mainForm" method="post"
					action="Blank.xhtml">
					<input type="hidden" name="event" />
					<xsl:variable name="rUrl">
						javascript:submitFormEvent('mainForm','PackageHandlerPO.po?from=
						<xsl:value-of select="$from_element" />
						&#38;sortCriterion=
						<xsl:value-of select="$sortCriterion" />
						&#38;sortAsc=
						<xsl:value-of select="$sortAsc" />
						','refresh')
					</xsl:variable>

					<table class="title_style" width="85%" border="0"
						align="center" cellpadding="0" cellspacing="0">
						<tr>
							<td width="2%" />
							<td width="30%">
								<div align="left">
									<img src="media/enhydra200_200.gif" />
								</div>
							</td>
							<td>
								<table class="title_style" width="100%"
									border="0" align="center" cellpadding="0" cellspacing="0">
									<tr>
										<td align="right"
											class="title_style" colspan="2" height="15">
										</td>
									</tr>
									<tr>
										<td align="right"
											class="title_style" colspan="2">
											<select
												name="package_name">
												<xsl:for-each
													select="xpil:PackageInstances">
													<xsl:for-each
														select="xpil:InstanceExtendedAttributes">
														<xsl:for-each
															select="xpil:InstanceExtendedAttribute">
															<xsl:variable
																name="opt">
																<xsl:value-of
																	select="@Name" />
															</xsl:variable>
															<option
																value="{$opt}">
																<xsl:value-of
																	select="@Name" />
															</option>
														</xsl:for-each>
													</xsl:for-each>
												</xsl:for-each>
											</select>
											<xsl:variable
												name="tUrl">
												javascript:submitFormEvent('mainForm','PackageHandlerPO.po?from=
												<xsl:value-of
													select="$from_element" />
												&#38;sortCriterion=
												<xsl:value-of
													select="$sortCriterion" />
												&#38;sortAsc=
												<xsl:value-of
													select="$sortAsc" />
												','load')
											</xsl:variable>
											<a href="{$tUrl}">
												<img
													src="media/load.bmp" border="0" alt="Load Package" />
											</a>
										</td>
									</tr>
									<tr>
										<td align="right"
											class="title_style" colspan="2" height="15" />
									</tr>
									<tr>
										<td align="left"
											class="title_style">
											<xsl:call-template
												name="Navigation" />
										</td>
										<td align="right"
											class="title_style">
											<a
												href="WorklistHandlerPO.po">
												Work List
											</a>
										</td>
									</tr>
								</table>
							</td>
							<td width="2%" />
						</tr>
						<tr>
							<td class="body_upper" colspan="4"
								height="4" />
						</tr>
						<tr>
                     <td align="left" class="body_home" width="2%"/>
   						<td align="center" class="body_home" height="15">
   							Package List
   						</td>
   						<td align="right" class="body_home" height="15">
   							User: <xsl:value-of select="$username" />
   					   </td>
                     <td align="left" class="body_home" width="2%"/>
						</tr>
						<tr>
							<td class="body_lower" colspan="4"
								height="1" />
						</tr>
						<tr>
							<td colspan="4">
								<table width="100%" hight="100%"
									border="1" cellpadding="0" cellspacing="0" class="body_main">
									<tr>
										<xsl:variable name="url">javascript:submitFormEvent('mainForm','PackageHandlerPO.po?from=<xsl:value-of select="$from_element"/>&#38;sortCriterion=id&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')"/>','sort')</xsl:variable>
										<td class="main_header_text">
											<div align="center">
												<a href="{$url}">Id</a>
											</div>

										</td>
										<xsl:variable name="url">javascript:submitFormEvent('mainForm','PackageHandlerPO.po?from=<xsl:value-of select="$from_element"/>&#38;sortCriterion=name&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')"/>','sort')</xsl:variable>
										<td class="main_header_text">
											<div align="center">
												<a href="{$url}">Name</a>
											</div>
										</td>
										<xsl:variable name="url">javascript:submitFormEvent('mainForm','PackageHandlerPO.po?from=<xsl:value-of select="$from_element"/>&#38;sortCriterion=version&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')"/>','sort')</xsl:variable>
										<td class="main_header_text">
											<div align="center">
												<a href="{$url}">Version</a>
											</div>
										</td>
										<td class="main_header_text"
											width="150">
											<div align="center">
												Actions
											</div>
										</td>

									</tr>
									<xsl:for-each select="//.">
										<xsl:choose>
											<xsl:when
												test="name()='xpil:PackageInstance'">
												<tr
													class="content_label_text" bgcolor="white">
													<td
														align="center">
														<xsl:value-of
															select="@Id" />
													</td>
													<td
														align="center">
														<xsl:value-of
															select="xpdl:Package/@Name" />
													</td>
													<td
														align="center">
														<xsl:value-of
															select="@Version" />
													</td>


													<td colspan="3"
														class="title_style" height="30" align="center">
														<xsl:variable
															name="unloadUrl">
															javascript:submitFormEvent('mainForm','PackageHandlerPO.po?from=
															<xsl:value-of
																select="$from_element" />
															&#38;sortCriterion=
															<xsl:value-of
																select="$sortCriterion" />
															&#38;sortAsc=
															<xsl:value-of
																select="$sortAsc" />
															&#38;name=
															<xsl:value-of
																select="@Id" />
															','unload')
														</xsl:variable>
														<xsl:variable
															name="updateUrl">
															javascript:submitFormEvent('mainForm','PackageHandlerPO.po?from=
															<xsl:value-of
																select="$from_element" />
															&#38;sortCriterion=
															<xsl:value-of
																select="$sortCriterion" />
															&#38;sortAsc=
															<xsl:value-of
																select="$sortAsc" />
															&#38;up_name=
															<xsl:value-of
																select="@Id" />
															','update')
														</xsl:variable>


														<a
															href="{$unloadUrl}" class="link_text">
															<img
																src="media/delete2.gif" border="0"
																alt="Unload package"  />
														</a>
														<a
															href="{$updateUrl}" class="link_text">
															<img
																src="media/update.gif" border="0" alt="Update package"/>
														</a>

													</td>
												</tr>
											</xsl:when>
										</xsl:choose>
									</xsl:for-each>
								</table>
							</td>
						</tr>
						<tr>
							<td colspan="3" class="title_style"
								height="30" align="right">
								<a href="{$rUrl}">
									<img src="media/refresh.bmp"
										border="0" alt="Refresh Package List" />
								</a>
							</td>
							<td width="2%" />
						</tr>
						<tr>
							<td align="left" class="body_bottom"
								width="2%" />
							<td align="left" class="body_bottom"
								height="15">
                        &#169; 2006 Together Teaml&#246;sungen
							</td>
							<td class="body_bottom" height="15"
								align="right">
								<xsl:variable name="loUrl">
									javascript:submitFormEvent('mainForm','WorklistHandlerPO.po','logout')
								</xsl:variable>
								<a href="{$loUrl}">Log-out</a>
							</td>
							<td align="left" class="body_bottom"
								width="2%" />
						</tr>
					</table>
				</form>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>
