<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" exclude-result-prefixes="xpil" xmlns:xpil="http://www.together.at/2006/XPIL1.0" xmlns:xpdl="http://www.wfmc.org/2002/XPDL1.0" version="1.0">
   <xsl:output method="html"/>
   <xsl:param name="username" select="u"/>
   <xsl:param name="from_element" select="11"/>
   <xsl:param name="to_element" select="20"/>
   <xsl:param name="sortCriterion" select="20"/>
   <xsl:param name="sortAsc" select="true"/>
   <xsl:param name="total_number" select="200"/>
   <xsl:param name="navig_url" select="ProcessHandlerPO.po"/>
   <xsl:include xmlns:xsl="http://www.w3.org/1999/XSL/Transform" href="navigation.xsl"/>
   <xsl:template match="xpil:ExtendedWorkflowFacilityInstance">
   <html xmlns="http://www.w3.org/1999/xhtml">
      <head>
         <title>Process Instances</title>
         <link rel="stylesheet" type="text/css" href="media/wlh.css"/>
         <script type="text/javascript">
function submitForm(formId, actionAttr) {
     var formTag = document.getElementById(formId);
     formTag.action=actionAttr;
     formTag.submit();
}
function submitFormEvent(formId, actionAttr,event) {
     var formTag = document.getElementById(formId);
     formTag.action=actionAttr;
     formTag.event.value=event;
     formTag.submit();
}
         </script>
      </head>
      <body class="body_home">
         <form id="mainForm" name="mainForm" method="post" action="Blank.xhtml">
            <input type="hidden" name="event" />
            <xsl:variable name="rUrl">javascript:submitFormEvent('mainForm','ProcessHandlerPO.po?from=<xsl:value-of select="$from_element"/>&#38;sortCriterion=<xsl:value-of select="$sortCriterion"/>&#38;sortAsc=<xsl:value-of select="$sortAsc"/>','refresh')</xsl:variable>
            <table class="title_style" width="85%" border="0" align="center" cellpadding="0" cellspacing="0">
               <tr>
                  <td width="2%"/>
                  <td width="30%">
                     <div align="left">
                        <img src="media/enhydra200_200.gif"/>
                     </div>
                  </td>
                  <td>
                     <table class="title_style" width="100%" border="0" align="center" cellpadding="0" cellspacing="0">
                        <tr>
                           <td align="right" class="title_style" colspan="2" height="15">
                           </td>
                        </tr>
                        <tr>
                           <xsl:choose>
                              <xsl:when test="xpil:WorkflowProcessFactoryInstance">
                                 <td align="right" class="title_style" colspan="2">
                                    <select name="process_manager">
                                       <xsl:for-each select="xpil:WorkflowProcessFactoryInstance">
                                          <xsl:variable name="opt">
                                             <xsl:value-of select="@Id"/>
                                          </xsl:variable>
                                          <option value="{$opt}">
                                             <xsl:value-of select="xpdl:WorkflowProcess/@Name"/>
                                          </option>
                                       </xsl:for-each>
                                    </select>
                                    <xsl:variable name="tUrl">javascript:submitFormEvent('mainForm','ProcessHandlerPO.po?from=<xsl:value-of select="$from_element"/>&#38;sortCriterion=<xsl:value-of select="$sortCriterion"/>&#38;sortAsc=<xsl:value-of select="$sortAsc"/>','create')</xsl:variable>
                                    <a href="{$tUrl}">
                                       <img src="media/create_proc.bmp" border="0" alt="Create New Process Instance"/>
                                    </a>
                                 </td>
                              </xsl:when>
                              <xsl:otherwise>
                                 <td class="title_style" height="20" colspan="2">
                                    <img src="media/blank.gif" alt="" width="1"/>
                                 </td>
                              </xsl:otherwise>
                           </xsl:choose>
                        </tr>
                        <tr>
                           <td align="right" class="title_style" colspan="2" height="15"/>
                        </tr>
                        <tr>
                           <td align="left" class="title_style">
                              <xsl:call-template name="Navigation"/>
                           </td>
                           <td align="right" class="title_style">
                              <a href="WorklistHandlerPO.po">
                                 Work List
                              </a>
                           </td>
                        </tr>
                     </table>
                  </td>
                  <td width="2%"/>
               </tr>
               <tr>
                  <td class="body_upper" colspan="4" height="4"/>
               </tr>
               <tr>
                  <td align="left" class="body_home" width="2%"/>
						<td align="center" class="body_home" height="15">
							Process List
						</td>
						<td align="right" class="body_home" height="15">
							User: <xsl:value-of select="$username" />
					   </td>
                  <td align="left" class="body_home" width="2%"/>
               </tr>
               <tr>
                  <td class="body_lower" colspan="4" height="1"/>
               </tr>
               <tr>
                  <td colspan="4">
                     <table width="100%" hight="100%" border="1" cellpadding="0" cellspacing="0" class="body_main">
                        <tr>
                           <xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessHandlerPO.po?from=<xsl:value-of select="$from_element"/>&#38;sortCriterion=name&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')"/>','sort')</xsl:variable>
                           <td class="main_header_text">
                              <div align="center"><a href="{$url}"
								 >Name</a></div>
                           </td>
                           <xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessHandlerPO.po?from=<xsl:value-of select="$from_element"/>&#38;sortCriterion=requester&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')"/>','sort')</xsl:variable>
                           <td class="main_header_text">
                              <div align="center"><a href="{$url}"
								  >Requester</a></div>
                           </td>
                           <xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessHandlerPO.po?from=<xsl:value-of select="$from_element"/>&#38;sortCriterion=priority&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')"/>','sort')</xsl:variable>
                           <td class="main_header_text">
                              <div align="center">
								  <a href="{$url}"
									   >Priority
								  </a>
							  </div>
                           </td>
                           <xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessHandlerPO.po?from=<xsl:value-of select="$from_element"/>&#38;sortCriterion=createdtime&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')"/>','sort')</xsl:variable>
                           <td class="main_header_text">
                              <div align="center"><a href="{$url}"
								  >Created</a></div>
                           </td>
                           <td class="main_header_text">
                              <div align="center">Finished</div>
                           </td>
                           <xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessHandlerPO.po?from=<xsl:value-of select="$from_element"/>&#38;sortCriterion=state&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')"/>','sort')</xsl:variable>
                           <td class="main_header_text">
                              <div align="center"><a href="{$url}"
								  >State</a></div>
                           </td>
                           <td class="main_header_text">
                              <div align="center">Actions</div>
                           </td>
                        </tr>
                        <xsl:for-each select="//.">
                           <xsl:choose>
                              <xsl:when test="name()='xpil:MainWorkflowProcessInstance' or name()='xpil:SubWorkflowProcessInstance'">
                                 <tr class="content_label_text" bgcolor="white">
                                    <td align="center">
                                       <xsl:value-of select="@Name"/>
                                    </td>
                                    <td align="center">
                                       <xsl:value-of select="@RequesterUsername"/>
                                    </td>
                                    <td align="center">
                                       <xsl:value-of select="xpil:InstancePriority"/>
                                    </td>
                                    <td align="center">
                                       <xsl:value-of select="concat(substring(@Created,0,11),' ',substring(@Created,12,5))"/>
                                    </td>
                                    <xsl:choose>
                                       <xsl:when test="@State='open.running'">
                                          <td align="center">
                                             -
                                          </td>
                                       </xsl:when>
                                       <xsl:otherwise>
                                          <td align="center">
                                             <xsl:value-of select="concat(substring(@Finished,0,11),' ',substring(@Finished,12,5))"/>
                                          </td>
                                       </xsl:otherwise>
                                    </xsl:choose>
                                    <td align="center">
                                       <xsl:value-of select="@State"/>
                                    </td>
                                   <xsl:variable
														name="detailUrl">
														javascript:submitFormEvent('mainForm','ProcessHandlerPO.po?from=
														<xsl:value-of
															select="$from_element" />
														&#38;sortCriterion=
														<xsl:value-of
															select="$sortCriterion" />
														&#38;sortAsc=
														<xsl:value-of
															select="$sortAsc" />
														&#38;pro_id=
														<xsl:value-of
															select="@Id" />
														&#38;page_ref=ProcessHandlerPO.po','details')
													</xsl:variable>
													<td colspan="3"
														class="title_style" height="30" align="center">
														<a
															href="{$detailUrl}">
															<img
																src="media/gear_information.gif" alt="Process details"
																border="0" />
														</a>
													</td>
                                 </tr>
                              </xsl:when>
                           </xsl:choose>
                        </xsl:for-each>
                     </table>
                  </td>
               </tr>
               <tr>
                  <td colspan="3" class="title_style" height="30" align="right">
                     <a href="{$rUrl}">
                        <img src="media/refresh.bmp" border="0" alt="Refresh Process List"/>
                     </a>
                  </td>
						<td width="2%"/>
               </tr>
               <tr>
                  <td align="left" class="body_bottom" width="2%"/>
                  <td align="left" class="body_bottom" height="15">
                     &#169; 2006 Together Teaml&#246;sungen
                  </td>
                  <td class="body_bottom" height="15" align="right">
                     <xsl:variable name="loUrl">javascript:submitFormEvent('mainForm','WorklistHandlerPO.po','logout')</xsl:variable>
                     <a href="{$loUrl}">
                        Log-out
                     </a>
                  </td>
                  <td align="left" class="body_bottom" width="2%"/>
               </tr>
            </table>
         </form>
      </body>
   </html>
   </xsl:template>
</xsl:stylesheet>
