<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	exclude-result-prefixes="xpil"
	xmlns:xpil="http://www.together.at/2006/XPIL1.0"
	xmlns:xpdl="http://www.wfmc.org/2002/XPDL1.0" version="1.0">
	<xsl:output method="html" />
	<xsl:param name="username" select="u" />
	<xsl:param name="from_element" select="11" />
	<xsl:param name="to_element" select="20" />
	<xsl:param name="sortCriterion" select="20" />
	<xsl:param name="sortAsc" select="true" />
	<xsl:param name="total_number" select="200" />
	<xsl:param name="navig_url" select="RepositoryHandlerPO.po" />
	<xsl:include xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
		href="navigation.xsl" />
	<xsl:template match="xpil:ExtendedWorkflowFacilityInstance">
		<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
				<title>Package Instances</title>
				<link rel="stylesheet" type="text/css"
					href="media/wlh.css" />
				<script type="text/javascript">
					function submitForm(formId, actionAttr) { var
					formTag = document.getElementById(formId);
					formTag.action=actionAttr; formTag.submit(); }
					function submitFormEvent(formId, actionAttr,event) {
					var formTag = document.getElementById(formId);
					formTag.action=actionAttr;
					formTag.event.value=event; formTag.submit(); }
				</script>
			</head>
			<body class="body_home">
				<form id="mainForm" name="mainForm" method="post"
					action="Blank.xhtml">
					<input type="hidden" name="event" />


					<xsl:variable name="rUrl">
						javascript:submitFormEvent('mainForm','RepositoryHandlerPO.po?from=
						<xsl:value-of select="$from_element" />
						&#38;sortCriterion=
						<xsl:value-of select="$sortCriterion" />
						&#38;sortAsc=
						<xsl:value-of select="$sortAsc" />
						','refresh')
					</xsl:variable>


					<table class="title_style" width="85%" border="0"
						align="center" cellpadding="0" cellspacing="0">
						<tr>
							<td width="2%" />
							<td width="30%">
								<div align="left">
									<img src="media/enhydra200_200.gif" />
								</div>
							</td>
							<td>
								<table class="title_style" width="100%"
									border="0" align="center" cellpadding="0" cellspacing="0">
									<tr>
										<td align="right"
											class="title_style" colspan="2" height="15">
										</td>
									</tr>
									<tr>
										<td align="right"
											class="title_style" colspan="2" height="15" />
									</tr>
									<tr>
										<td align="left"
											class="title_style">
											<xsl:call-template
												name="Navigation" />
										</td>
										<td align="right"
											class="title_style">
											<a
												href="WorklistHandlerPO.po">
												Work List
											</a>
										</td>
									</tr>
								</table>
							</td>
							<td width="2%" />
						</tr>
						<tr>
							<td class="body_upper" colspan="4"
								height="4" />
						</tr>
						<tr>
                     <td align="left" class="body_home" width="2%"/>
   						<td align="center" class="body_home" height="15">
   							XPDL Repository
   						</td>
   						<td align="right" class="body_home" height="15">
   							User: <xsl:value-of select="$username" />
   					   </td>
                     <td align="left" class="body_home" width="2%"/>
						</tr>
						<tr>
							<td class="body_lower" colspan="4"
								height="1" />
						</tr>
						<tr>
							<td colspan="4">
								<table width="100%" hight="100%"
									border="1" cellpadding="0" cellspacing="0" class="body_main">
									<tr>
									<xsl:variable name="url">javascript:submitFormEvent('mainForm','RepositoryHandlerPO.po?from=<xsl:value-of select="$from_element"/>&#38;sortCriterion=&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')"/>','sort')</xsl:variable>

										<td class="main_header_text">
											<div align="center">
												<a href="{$url}">Name</a>
											</div>
										</td>
										<td class="main_header_text"
											width="150">
											<div align="center">
												Actions
											</div>
										</td>
									</tr>
									<xsl:for-each select="//.">
										<xsl:choose>
											<xsl:when
												test="name()='xpil:InstanceExtendedAttribute'">
												<xsl:variable
													name="deleteUrl">
													javascript:submitFormEvent('mainForm','RepositoryHandlerPO.po?from=
													<xsl:value-of
														select="$from_element" />
													&#38;sortCriterion=
													<xsl:value-of
														select="$sortCriterion" />
													&#38;sortAsc=
													<xsl:value-of
														select="$sortAsc" />
													&#38;name=
													<xsl:value-of
														select="@Name" />
													','delete')
												</xsl:variable>
												<tr
													class="content_label_text" bgcolor="white">
													<td
														align="center">
														<xsl:value-of
															select="@Name" />
													</td>
													<td colspan="3"
														class="title_style" height="30" align="center">
														<a
															href="{$deleteUrl}" class="link_text">
															<img
																src="media/delete2.gif" border="0" alt="Delete" />
														</a>
													</td>
												</tr>
											</xsl:when>
										</xsl:choose>
									</xsl:for-each>
								</table>
							</td>
						</tr>
						<tr>
							<td colspan="3" class="title_style"
								height="30" align="right">
								<a href="{$rUrl}">
									<img src="media/refresh.bmp"
										border="0" alt="Refresh Repository" />
								</a>
							</td>
							<td width="2%" />
						</tr>
						<tr>
							<td align="left" class="body_bottom"
								width="2%" />
							<td align="left" class="body_bottom"
								height="15">
                        &#169; 2006 Together Teaml&#246;sungen
							</td>
							<td class="body_bottom" height="15"
								align="right">
								<xsl:variable name="loUrl">
									javascript:submitFormEvent('mainForm','WorklistHandlerPO.po','logout')
								</xsl:variable>
								<a href="{$loUrl}">Log-out</a>
							</td>
							<td align="left" class="body_bottom"
								width="2%" />
						</tr>
					</table>
				</form>
				<form id="mainForm1" name="mainForm1" method="post"
					action="RepositoryHandlerPO.po?event=upload"
					enctype="multipart/form-data">
					<table class="body_home" width="800" border="0"
						align="center" cellpadding="0" cellspacing="0">
						<tr>
							<td align="right">
							Upload new package:
								<input type="file"
									name="contextFilePath" size="40" maxlength="200" />
							</td>
							<td align="center">
								<input type="submit" value="Upload" />
							</td>
						</tr>

					</table>
				</form>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>
