<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" exclude-result-prefixes="xpil" xmlns:xpil="http://www.together.at/2006/XPIL1.0" xmlns:xpdl="http://www.wfmc.org/2002/XPDL1.0" version="1.0">
   <xsl:output method="html"/>
   <xsl:param name="username" select="u"/>
   <xsl:param name="from_element" select="11"/>
   <xsl:param name="to_element" select="20"/>
   <xsl:param name="sortCriterion" select="20"/>
   <xsl:param name="sortAsc" select="true"/>
   <xsl:param name="total_number" select="200"/>
   <xsl:param name="navig_url" select="WorklistHandlerPO.po"/>
   <xsl:include xmlns:xsl="http://www.w3.org/1999/XSL/Transform" href="navigation.xsl"/>
   <xsl:template match="xpil:ExtendedWorkflowFacilityInstance">
   <html xmlns="http://www.w3.org/1999/xhtml">
      <head>
         <title>Worklist Handler</title>
         <link rel="stylesheet" type="text/css" href="media/wlh.css"/>
         <script type="text/javascript">

function submitForm(formId, actionAttr) {
     var formTag = document.getElementById(formId);
     formTag.action=actionAttr;
     formTag.submit();
}
function submitFormEvent(formId, actionAttr,event) {
     var formTag = document.getElementById(formId);
     formTag.action=actionAttr;
      formTag.event.value=event;
     formTag.submit();
}
function submitFormWithEvent(formId, actionAttr,proId,actId,event,accepted) {
     var formTag = document.getElementById(formId);
     formTag.action=actionAttr;
     formTag.pro_id.value=proId;
     formTag.act_id.value=actId;
     formTag.accepted.value=accepted;
     formTag.event.value=event;
     formTag.submit();
}

         </script>
      </head>
      <body class="body_home">
         <form id="mainForm" name="mainForm" method="post" action="Blank.xhtml">
            <input type="hidden" name="pro_id"/>
            <input type="hidden" name="act_id"/>
            <input type="hidden" name="event"/>
            <input type="hidden" name="accepted"/>
            <xsl:variable name="rUrl">javascript:submitFormEvent('mainForm','WorklistHandlerPO.po?from=<xsl:value-of select='$from_element'/>&#38;sortCriterion=<xsl:value-of select="$sortCriterion"/>&#38;sortAsc=<xsl:value-of select="$sortAsc"/>','refresh')</xsl:variable>
            <table class="title_style" width="85%" border="0" align="center" cellpadding="0" cellspacing="0">
               <tr>
                  <td width="2%"/>
                  <td width="30%">
                     <div align="left">
                        <img src="media/enhydra200_200.gif"/>
                     </div>
                  </td>
                  <td>
                     <table class="title_style" width="100%" border="0" align="center" cellpadding="0" cellspacing="0">
                        <tr>
                           <td align="right" class="title_style" colspan="2" height="15">
                           </td>
                        </tr>
                        <tr>
                           <xsl:choose>
                              <xsl:when test="xpil:WorkflowProcessFactoryInstance">
                                 <td align="right" class="title_style" colspan="2">
                                    <select name="process_manager">
                                       <xsl:for-each select="xpil:WorkflowProcessFactoryInstance">
                                          <xsl:variable name="opt">
                                             <xsl:value-of select="@Id"/>
                                          </xsl:variable>
                                          <option value="{$opt}">
                                             <xsl:value-of select="xpdl:WorkflowProcess/@Name"/>
                                          </option>
                                       </xsl:for-each>
                                    </select>
                                    <xsl:variable name="tUrl">javascript:submitFormEvent('mainForm','WorklistHandlerPO.po?from=<xsl:value-of select='$from_element'/>&#38;sortCriterion=<xsl:value-of select="$sortCriterion"/>&#38;sortAsc=<xsl:value-of select="$sortAsc"/>','create')</xsl:variable>
                                    <a href="{$tUrl}">
                                       <img src="media/create_proc.bmp" border="0" alt="Create New Process Instance"/>
                                    </a>
                                 </td>
                              </xsl:when>
                              <xsl:otherwise>
                                 <td class="title_style" height="20" colspan="2">
                                    <img src="media/blank.gif" alt="" width="1"/>
                                 </td>
                              </xsl:otherwise>
                           </xsl:choose>
                        </tr>
                        <tr>
                           <td align="right" class="title_style" colspan="2" height="15"/>
                        </tr>
                        <tr>
                           <td align="left" class="title_style">
                              <xsl:call-template name="Navigation"/>
                           </td>
                           <td align="right" class="title_style">
                              <a href="RepositoryHandlerPO.po">Repository</a>
                              <a href="PackageHandlerPO.po">Package list</a>
                              <a href="ProcessInstantiationHandlerPO.po">Process instantiation</a>
                              <a href="ProcessHandlerPO.po">Process list</a>
                           </td>
                        </tr>
                     </table>
                  </td>
                  <td width="2%"/>
               </tr>
               <tr>
                  <td class="body_upper" colspan="4" height="4"/>
               </tr>
               <tr>
                  <td align="left" class="body_home" width="2%"/>
						<td align="center" class="body_home" height="15">
							Work List
						</td>
						<td align="right" class="body_home" height="15">
							User: <xsl:value-of select="$username" />
					   </td>
                  <td align="left" class="body_home" width="2%"/>
               </tr>
               <tr>
                  <td class="body_lower" colspan="4" height="1"/>
               </tr>
               <tr>
                  <td colspan="4">
                     <table width="100%" hight="100%" border="1" cellpadding="0" cellspacing="0" class="body_main">
                        <tr height="20">
                           <xsl:variable name="url">javascript:submitFormEvent('mainForm','WorklistHandlerPO.po?from=<xsl:value-of select="$from_element"/>&#38;sortCriterion=accepted&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')"/>','sort')</xsl:variable>
                           <td class="main_header_text">
							  <a href="{$url}">
								  <img src="media/accept.gif" alt="" border="0" />
							  </a>
                           </td>
                           <td class="main_header_text">
                              <div align="center">Process</div>
                           </td>
                           <td class="main_header_text">
                              <div align="center">Activity</div>
                           </td>
                           <td class="main_header_text">
                              <div align="center">Priority</div>
                           </td>
                           <td class="main_header_text">
                              <div align="center">Description</div>
                           </td>
                           <xsl:variable name="url">javascript:submitFormEvent('mainForm','WorklistHandlerPO.po?from=<xsl:value-of select="$from_element"/>&#38;sortCriterion=createdtime&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')"/>','sort')</xsl:variable>
                           <td class="main_header_text">
                              <div align="center"><a href="{$url}"
								  >Created</a></div>
                           </td>
                           <td class="main_header_text">
                              <div align="center">Actions</div>
                           </td>
                        </tr>
                        <xsl:for-each select="//.">
                           <xsl:choose>
                              <xsl:when test="name()='xpil:MainWorkflowProcessInstance' or name()='xpil:SubWorkflowProcessInstance'">
                                 <xsl:variable name="proid">
                                    <xsl:value-of select="@Id"/>
                                 </xsl:variable>
                                 <xsl:variable name="actId">
                                    <xsl:value-of select="xpil:ActivityInstances/xpil:ManualActivityInstance/@Id"/>
                                 </xsl:variable>
                                 <xsl:variable name="priority">
                                    <xsl:apply-templates select="xpil:Priority"/>
                                 </xsl:variable>
                                 <xsl:for-each select="xpil:ActivityInstances/xpil:ManualActivityInstance">
                                    <xsl:variable name="accepted">
                                       <xsl:value-of select="xpil:AssignmentInstances/xpil:AssignmentInstance/@IsAccepted"/>
                                    </xsl:variable>
                                    <xsl:variable name="url1">javascript:submitFormWithEvent('mainForm','WorklistHandlerPO.po?from=<xsl:value-of select="$from_element"/>&#38;sortCriterion=<xsl:value-of select="$sortCriterion"/>&#38;sortAsc=<xsl:value-of select="$sortAsc"/>','<xsl:value-of select="../../@Id"/>','<xsl:value-of select="@Id"/>','accepted','<xsl:value-of select="xpil:AssignmentInstances/xpil:AssignmentInstance/@IsAccepted"/>')</xsl:variable>
                                    <tr class="content_label_text">
                                       <td class="content_label_text" width="3%">
                                          <xsl:choose>
                                             <xsl:when test="$accepted='true'">
                                                <input name="{$actId}" type="checkbox" checked="{$accepted}" onclick="{$url1}"/>
                                             </xsl:when>
                                             <xsl:otherwise>
                                                <input name="{$actId}" type="checkbox" onclick="{$url1}"/>
                                             </xsl:otherwise>
                                          </xsl:choose>
                                       </td>
                                       <td align="center">
                                          <xsl:value-of select="../../@Name"/>
                                       </td>
                                       <td align="center">
                                          <xsl:value-of select="@Name"/>
                                       </td>
                                       <td align="center">
                                          <xsl:value-of select="xpil:InstancePriority"/>
                                       </td>
                                       <td align="center">
                                          <xsl:choose>
                                             <xsl:when test="xpil:InstanceDescription!=''">
                                                <xsl:value-of select="xpil:InstanceDescription"/>
                                             </xsl:when>
                                             <xsl:otherwise>
                                              -
                                            </xsl:otherwise>
                                          </xsl:choose>
                                       </td>
                                       <td align="center">
                                          <xsl:value-of select="concat(substring(@Created,0,11),' ',substring(@Created,12,5))"/>
                                       </td>
                                       <!--<xsl:variable name="url">javascript:var wnd=window.open('ActivityHandlerPO.po?pro_id=<xsl:value-of select="../../@Id"/>&#38;act_id=<xsl:value-of select="@Id"/>&#38;activity=yes','','toolbar=no,status=no,menubar=no,scrollbars=yes,left=250,top=60,width=700,height=600,resizable=yes');wnd.focus()</xsl:variable>-->
                                       <xsl:variable name="url">javascript:submitForm('mainForm','ActivityHandlerPO.po?pro_id=<xsl:value-of select="../../@Id"/>&#38;act_id=<xsl:value-of select="@Id"/>&#38;from=<xsl:value-of select='$from_element'/>&#38;sortCriterion=<xsl:value-of select="$sortCriterion"/>&#38;sortAsc=<xsl:value-of select="$sortAsc"/>','')</xsl:variable>
                                       <xsl:variable name="url2">javascript:submitFormWithEvent('mainForm','WorklistHandlerPO.po?from=<xsl:value-of select="$from_element"/>&#38;sortCriterion=<xsl:value-of select="$sortCriterion"/>&#38;sortAsc=<xsl:value-of select="$sortAsc"/>','<xsl:value-of select="../../@Id"/>','<xsl:value-of select="@Id"/>','complete','none')</xsl:variable>
                                       <td align="center">
                                          <xsl:choose>
                                             <xsl:when test="$accepted='true'">
                                                <table>
                                                   <tr>
                                                      <td>
                                                         <a href="{$url}"><img src="media/update.gif" border="0" alt="Update variable"/></a>
                                                      </td>
                                                      <td>
                                                         <a href="{$url2}"><img src="media/complete.gif" border="0" alt="Complete activity"/></a>
                                                      </td>
                                                   </tr>
                                                </table>
                                             </xsl:when>
                                             <xsl:otherwise>
                                                <img src="media/blank.gif" alt="" width="1"/>
                                             </xsl:otherwise>
                                          </xsl:choose>
                                       </td>
                                    </tr>
                                 </xsl:for-each>
                              </xsl:when>
                           </xsl:choose>
                        </xsl:for-each>
                     </table>
                  </td>
               </tr>
               <tr>
                  <td colspan="3" class="title_style" height="30" align="right">
                     <a href="{$rUrl}">
                        <img src="media/refresh.bmp" border="0" alt="Refresh Work List"/>
                     </a>
                  </td>
						<td width="2%"/>
               </tr>
               <tr>
                  <td align="left" class="body_bottom" width="2%"/>
                  <td align="left" class="body_bottom" height="15">
                     &#169; 2006 Together Teaml&#246;sungen
                  </td>
                  <td class="body_bottom" height="15" align="right">
                     <xsl:variable name="loUrl">javascript:submitFormEvent('mainForm','WorklistHandlerPO.po','logout')</xsl:variable>
                     <a href="{$loUrl}">
                        Log-out
                     </a>
                  </td>
                  <td align="left" class="body_bottom" width="2%"/>
               </tr>
            </table>
         </form>
      </body>
   </html>
   </xsl:template>
</xsl:stylesheet>
