package org.enhydra.wlh.presentation;

import org.w3c.dom.html.HTMLImageElement;
import org.w3c.dom.html.HTMLLinkElement;

import com.lutris.appserver.server.httpPresentation.HttpPresentation;
import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;
import com.lutris.appserver.server.httpPresentation.HttpPresentationException;

public class LoginPresentation implements HttpPresentation {

   public void run(HttpPresentationComms comms) throws HttpPresentationException {

      LoginHTML htmlObj = (LoginHTML) comms.xmlcFactory.create(LoginHTML.class);
      try {
         String logo = comms.application.getConfig()
            .getString("WorkListHandler.DefaultLogoImage", "media/enhydra200_200.gif");
         HTMLImageElement img=htmlObj.getElementLogoImg();
         img.setSrc(logo);
         String css = comms.application.getConfig()
            .getString("WorkListHandler.DefaultCSS", "media/wlh.css");
         HTMLLinkElement link=htmlObj.getElementCssLink();
         link.setHref(css);
      } catch (Exception ex) {

      }
      comms.response.writeDOM(htmlObj);
   }
}
