package org.enhydra.wlh.presentation;

import java.io.OutputStreamWriter;

import org.enhydra.wlh.WorkListHandler;
import org.enhydra.wlh.business.XMLProcessDetailBuilder;
import org.enhydra.wlh.presentation.utils.NavigConsts;
import org.enhydra.wlh.spec.utils.ParamConsts;
import org.enhydra.xml.xmlc.XMLObject;
import org.w3c.dom.Node;

import com.lutris.appserver.server.httpPresentation.ClientPageRedirectException;
import com.lutris.appserver.server.httpPresentation.HttpPresentationException;
import com.lutris.appserver.server.httpPresentation.HttpPresentationOutputStream;

public class ProcessDetailHandlerPO extends BasePO {

   public Node handleDefault() throws HttpPresentationException {

      return showPage();
   }

   public Node handleClose() throws HttpPresentationException {

      String page = myComms.request.getParameter("fromPage");
      String from_element = myComms.request.getParameter("from");
      String sortCriterion = myComms.request.getParameter("sortCriterion");
      String sortOrder = myComms.request.getParameter("sortAsc");

      if (sortCriterion == null) {
         sortCriterion = "";
      }
      String sortAsc = "true";
      if (sortOrder != null
          && (sortOrder.equalsIgnoreCase("true") || sortOrder.equalsIgnoreCase("false"))) {
         sortAsc = sortOrder;
      }

      throw new ClientPageRedirectException(page
                                            + "?from=" + from_element
                                            + "&sortCriterion=" + sortCriterion
                                            + "&sortAsc=" + sortAsc);
   }

   protected boolean loggedInUserRequired() {
      // TODO Auto-generated method stub
      return false;
   }

   protected XMLObject showPage() throws HttpPresentationException {

      try {

         String xslt = myComms.request.getParameter(ParamConsts.XSL);
         // xslt="none";
         if (xslt == null) {
            xslt = myComms.application.getConfig()
               .getString("WorkListHandler."
                                + ParamConsts.PROPERTY_PREFIX_PROCESSDETAILS + ".xsl",
                          "none");
         }

         String xslDir = WorkListHandler.getXslDirectory();

         String pro_id = myComms.request.getParameter("pro_id");
         String page = myComms.request.getParameter("page_ref");
         String from = myComms.request.getParameter("from");
         String sortCriterion = myComms.request.getParameter("sortCriterion");
         String sortOrder = myComms.request.getParameter("sortAsc");

         if (sortCriterion == null) {
            sortCriterion = "";
         }
         String sortAsc = "true";
         if (sortOrder != null
             && (sortOrder.equalsIgnoreCase("true") || sortOrder.equalsIgnoreCase("false"))) {
            sortAsc = sortOrder;
         }

         XMLProcessDetailBuilder xmlImp = new XMLProcessDetailBuilder(getUsername(),
                                                                      WorkListHandler.config,
                                                                      from,
                                                                      sortCriterion,
                                                                      sortAsc,
                                                                      pro_id,
                                                                      page);
         String finall = null;
         if (!xslt.equals("none")) {

            finall = xmlImp.getResult(xslDir + "/" + xslt + ".xsl");

         } else {
            myComms.response.setContentType("text/xml");
            HttpPresentationOutputStream os = myComms.response.getOutputStream();
            xmlImp.writeResult(os);
            myComms.response.flush();
            return null;
         }

         HttpPresentationOutputStream os = myComms.response.getOutputStream();
         OutputStreamWriter out = new OutputStreamWriter(os);
         out.write(finall);
         out.flush();

         return null;
      } catch (Exception ex) {
         ex.printStackTrace();
         throw new PresentationException("Can't show page", ex);
      }
   }
}
