package org.enhydra.wlh.presentation;

import java.io.OutputStreamWriter;

import org.enhydra.shark.api.client.wfmodel.WfActivity;
import org.enhydra.shark.api.common.SharkConstants;
import org.enhydra.wlh.WorkListHandler;
import org.enhydra.wlh.business.SharkUtils;
import org.enhydra.wlh.business.XMLProcessInstanceBuilder;
import org.enhydra.wlh.presentation.utils.NavigConsts;
import org.enhydra.wlh.spec.utils.ParamConsts;
import org.enhydra.xml.xmlc.XMLObject;
import org.w3c.dom.Node;

import com.lutris.appserver.server.httpPresentation.ClientPageRedirectException;
import com.lutris.appserver.server.httpPresentation.HttpPresentationException;
import com.lutris.appserver.server.httpPresentation.HttpPresentationOutputStream;

public class ProcessHandlerPO extends BasePO {

   public void testNodes() {

   }

   public Node handleDefault() throws HttpPresentationException {

      return showPage();

   }

   public XMLObject handleRefresh() throws HttpPresentationException {
      return showPage();
   }

   public XMLObject handleSort() throws HttpPresentationException {
      return showPage();
   }
   public XMLObject handleDetails() throws HttpPresentationException {
      
      String pro_id = myComms.request.getParameter(ParamConsts.PROCESS_ID);
      String page = myComms.request.getParameter(ParamConsts.PAGE_REF);
      String from_element = myComms.request.getParameter("from");
      String sortCriterion = myComms.request.getParameter("sortCriterion");
      String sortOrder = myComms.request.getParameter("sortAsc");

      if (sortCriterion == null) {
         sortCriterion = "";
      }
      String sortAsc = "true";
      if (sortOrder != null
          && (sortOrder.equalsIgnoreCase("true") || sortOrder.equalsIgnoreCase("false"))) {
         sortAsc = sortOrder;
      }
     
      throw new ClientPageRedirectException(NavigConsts.PROCESS_DETAIL_HANDLER
                                            + "?from=" +from_element
                                            + "&sortCriterion=" + sortCriterion
                                            + "&sortAsc=" + sortAsc
                                            + "&pro_id=" +pro_id
                                            + "&page_ref=" +page);
      
   }
   protected boolean loggedInUserRequired() {
      return true;
   }

   protected XMLObject showPage() throws HttpPresentationException {

      try {

         String xslt = myComms.request.getParameter(ParamConsts.XSL);
         //xslt="none";
         if (xslt == null) {
            xslt = myComms.application.getConfig()
               .getString("WorkListHandler."
                                + ParamConsts.PROPERTY_PREFIX_PROCESSLIST + ".xsl",
                          "none");
         }

         String xslDir = WorkListHandler.getXslDirectory();

         String pagingFrom = myComms.request.getParameter("from");
         String sortCriterion = myComms.request.getParameter("sortCriterion");
         String sortOrder = myComms.request.getParameter("sortAsc");

         if (sortCriterion == null) {
            sortCriterion = "";
         }
         String sortAsc = "true";
         if (sortOrder != null
             && (sortOrder.equalsIgnoreCase("true") || sortOrder.equalsIgnoreCase("false"))) {
            sortAsc = sortOrder;
         }

         XMLProcessInstanceBuilder xmlImp = new XMLProcessInstanceBuilder(getUsername(),
                                                                          WorkListHandler.config,
                                                                          pagingFrom,
                                                                          sortCriterion,
                                                                          sortAsc);
         String finall = null;
         if (!xslt.equals("none")) {

            finall = xmlImp.getResult(xslDir + "/" + xslt + ".xsl");

         } else {
            myComms.response.setContentType("text/xml");
            HttpPresentationOutputStream os = myComms.response.getOutputStream();
            xmlImp.writeResult(os);
            myComms.response.flush();
            return null;
         }

         HttpPresentationOutputStream os = myComms.response.getOutputStream();
         OutputStreamWriter out = new OutputStreamWriter(os);
         out.write(finall);
         out.flush();

         return null;
      } catch (Exception ex) {
         ex.printStackTrace();
         throw new PresentationException("Can't show page", ex);
      }
   }

   public XMLObject handleCreate() throws HttpPresentationException {

      try {
         String process_manager_name = myComms.request.getParameter(ParamConsts.PROCESS_MANAGER);
         String from_element = myComms.request.getParameter("from");
         String sortCriterion = myComms.request.getParameter("sortCriterion");
         String sortOrder = myComms.request.getParameter("sortAsc");

         if (sortCriterion == null) {
            sortCriterion = "";
         }
         String sortAsc = "true";
         if (sortOrder != null
             && (sortOrder.equalsIgnoreCase("true") || sortOrder.equalsIgnoreCase("false"))) {
            sortAsc = sortOrder;
         }

         boolean checkFirstActivity = myComms.application.getConfig()
            .getBoolean("WorkListHandler."
                              + ParamConsts.PROPERTY_PREFIX_PROCESSLIST
                              + ".checkforfirstactivity",
                        false);

         WfActivity act = SharkUtils.createProcess(getUsername(),
                                                   process_manager_name,
                                                   checkFirstActivity);
         if (act != null) {
            act.change_state(SharkConstants.STATE_OPEN_RUNNING);
            String qp = NavigConsts.ACTIVITY_HANDLER
                        + "?" + ParamConsts.PROCESS_ID + "=" + act.container().key()
                        + "&" + ParamConsts.ACTIVITY_ID + "=" + act.key();
            throw new ClientPageRedirectException(qp);
         }
         throw new ClientPageRedirectException(NavigConsts.PROCESS_HANDLER
                                               + "?from=" + from_element
                                               + "&sortCriterion=" + sortCriterion
                                               + "&sortAsc=" + sortAsc);
      } catch (Exception e) {
         throw new PresentationException("Problems with process creation!", e);
      }
   }

}
